/******************************************************************************
 // QSyncthingTray
 // Copyright (c) Matthias Frick, All rights reserved.
 //
 // This library is free software; you can redistribute it and/or
 // modify it under the terms of the GNU Lesser General Public
 // License as published by the Free Software Foundation; either
 // version 3.0 of the License, or (at your option) any later version.
 //
 // This library is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 // Lesser General Public License for more details.
 //
 // You should have received a copy of the GNU Lesser General Public
 // License along with this library.
 ******************************************************************************/

#include <iostream>
#include <qst/syncwebpage.h>

//------------------------------------------------------------------------------------//
#define UNUSED(x) (void)(x)
//------------------------------------------------------------------------------------//

SyncWebPage::SyncWebPage()
{
  connect(this, &QWebEnginePage::authenticationRequired,
    this, &SyncWebPage::requireAuthentication);
}


//------------------------------------------------------------------------------------//

SyncWebPage::~SyncWebPage()
{
  disconnect(this, &QWebEnginePage::authenticationRequired,
          this, &SyncWebPage::requireAuthentication);
}


//------------------------------------------------------------------------------------//

void SyncWebPage::updateConnInfo(QUrl url, Authentication authInfo)
{
  mAuthInfo = authInfo;
  setUrl(url);
}


//------------------------------------------------------------------------------------//

void SyncWebPage::requireAuthentication(
  const QUrl &, QAuthenticator *authenticator)
{
  authenticator->setUser(mAuthInfo.first);
  authenticator->setPassword(mAuthInfo.second);
}


//------------------------------------------------------------------------------------//

auto SyncWebPage::certificateError(
  const QWebEngineCertificateError &/*certificateError*/) -> bool
{
  return true; // TODO: Figure out whether there is a syncthing CA so we can use the
               // real certificate
}

//------------------------------------------------------------------------------------//
//------------------------------------------------------------------------------------//
// EOF
//------------------------------------------------------------------------------------//
